﻿using System;
using System.ComponentModel;
using System.Reflection;

namespace Inedo.Consolation
{
    internal sealed class GlobalConsoleOption : ConsoleOption
    {
        private PropertyInfo property;

        public GlobalConsoleOption(PropertyInfo property)
            : base(property)
        {
            this.property = property;
            this.IsFlag = property.PropertyType == typeof(bool) || property.PropertyType == typeof(bool?);
            var defaultValueAttribute = (DefaultValueAttribute)Attribute.GetCustomAttribute(property, typeof(DefaultValueAttribute));
            if (defaultValueAttribute != null)
                this.DefaultValue = defaultValueAttribute.Value;
        }

        public override object CurrentValue
        {
            get { return this.property.GetValue(null); }
        }

        public override void SetValue(string valueText)
        {
            this.property.SetValue(null, this.ParseValue(valueText, this.property.PropertyType));
        }
        public override void SetFlag(bool enableDisable)
        {
            this.property.SetValue(null, enableDisable);
        }
    }
}
